# wxLog Class Reference
[Logging]

`#include <wx/log.h>`

Inheritance diagram for wxLog:
[legend]

## Detailed Description

wxLog class defines the interface for the log targets used by wxWidgets logging functions as explained in the wxLog Classes Overview.

The only situations when you need to directly use this class is when you want to derive your own log target because the existing ones don't satisfy your needs.

Otherwise, it is completely hidden behind the wxLogXXX() functions and you may not even know about its existence.

Note:
  For console-mode applications, the default target is wxLogStderr, so that all wxLogXXX() functions print on `stderr` when `wxUSE_GUI` = 0.

##

Library: wxCore

Category: Logging

See also:
  wxLog Classes Overview, wxLogXXX() functions

## Public Member Functions
virtual void | Flush ()
| Some of wxLog implementations, most notably the standard wxLogGui class, buffer the messages (for example, to avoid showing the user a zillion of modal message boxes one after another -- which would be really annoying).
void | LogRecord (wxLogLevel level, const wxString &msg, time_t timestamp)
| Log the given record.
## Static Public Member Functions
Trace mask functions
static void | AddTraceMask (const wxString &mask)
| Add the mask to the list of allowed masks for wxLogTrace().
static void | ClearTraceMasks ()
| Removes all trace masks previously set with AddTraceMask().
static const wxArrayString & | GetTraceMasks ()
| Returns the currently allowed list of string trace masks.
static bool | IsAllowedTraceMask (const wxString &mask)
| Returns true if the mask is one of allowed masks for wxLogTrace().
static void | RemoveTraceMask (const wxString &mask)
| Remove the mask from the list of allowed masks for wxLogTrace().
Log target functions
static void | DontCreateOnDemand ()
| Instructs wxLog to not create new log targets on the fly if there is none currently (see GetActiveTarget()).
static wxLog * | GetActiveTarget ()
| Returns the pointer to the active log target (may be NULL).
static wxLog * | SetActiveTarget (wxLog *logtarget)
| Sets the specified log target as the active one.
static wxLog * | SetThreadActiveTarget (wxLog *logger)
| Sets a thread-specific log target.
static void | FlushActive ()
| Flushes the current log target if any, does nothing if there is none.
static void | Resume ()
| Resumes logging previously suspended by a call to Suspend().
static void | Suspend ()
| Suspends the logging until Resume() is called.
Log level functions
static wxLogLevel | GetLogLevel ()
| Returns the current log level limit.
static bool | IsLevelEnabled (wxLogLevel level, wxString component)
| Returns true if logging at this level is enabled for the current thread.
static void | SetComponentLevel (const wxString &component, wxLogLevel level)
| Sets the log level for the given component.
static void | SetLogLevel (wxLogLevel logLevel)
| Specifies that log messages with level greater (numerically) than logLevel should be ignored and not sent to the active log target.
Enable/disable features functions
static bool | EnableLogging (bool enable=true)
| Globally enable or disable logging.
static bool | IsEnabled ()
| Returns true if logging is enabled at all now.
static bool | GetRepetitionCounting ()
| Returns whether the repetition counting mode is enabled.
static void | SetRepetitionCounting (bool repetCounting=true)
| Enables logging mode in which a log message is logged once, and in case exactly the same message successively repeats one or more times, only the number of repetitions is logged.
static const wxString & | GetTimestamp ()
| Returns the current timestamp format string.
static void | SetTimestamp (const wxString &format)
| Sets the timestamp format prepended by the default log targets to all messages.
static void | DisableTimestamp ()
| Disables time stamping of the log messages.
static bool | GetVerbose ()
| Returns whether the verbose mode is currently active.
static void | SetVerbose (bool verbose=true)
| Activates or deactivates verbose mode in which the verbose messages are logged as the normal ones instead of being silently dropped.
## Protected Member Functions
Logging callbacks.
The functions which should be overridden by custom log targets. When defining a new log target, you have a choice between overriding DoLogRecord(), which provides maximal flexibility, DoLogTextAtLevel() which can be used if you don't intend to change the default log messages formatting but want to handle log messages of different levels differently or, in the simplest case, DoLogText().
virtual void | DoLogRecord (wxLogLevel level, const wxString &msg, const wxLogRecordInfo &info)
| Called to log a new record.
virtual void | DoLogTextAtLevel (wxLogLevel level, const wxString &msg)
| Called to log the specified string at given level.
virtual void | DoLogText (const wxString &msg)
| Called to log the specified string.

List of all members.

## Member Function Documentation

static void wxLog::AddTraceMask | ( | const wxString & | mask | ) | `[static]`

Add the mask to the list of allowed masks for wxLogTrace().

See also:
  RemoveTraceMask(), GetTraceMasks()

static void wxLog::ClearTraceMasks | ( |  | ) | `[static]`

Removes all trace masks previously set with AddTraceMask().

See also:
  RemoveTraceMask()

static void wxLog::DisableTimestamp | ( |  | ) | `[static]`

Disables time stamping of the log messages.

Since:
  2.9.0

virtual void wxLog::DoLogRecord | ( | wxLogLevel | level,
|  | const wxString & | msg,
|  | const wxLogRecordInfo & | info |
| ) |  |  | `[protected, virtual]`

Called to log a new record.

Any log message created by wxLogXXX() functions is passed to this method of the active log target. The default implementation prepends the timestamp and, for some log levels (e.g. error and warning), the corresponding prefix to msg and passes it to DoLogTextAtLevel().

You may override this method to implement custom formatting of the log messages or to implement custom filtering of log messages (e.g. you could discard all log messages coming from the given source file).

virtual void wxLog::DoLogText | ( | const wxString & | msg | ) | `[protected, virtual]`

Called to log the specified string.

A simple implementation might just send the string to `stdout` or `stderr` or save it in a file (of course, the already existing wxLogStderr can be used for this).

The base class version of this function asserts so it must be overridden if you don't override DoLogRecord() or DoLogTextAtLevel().

virtual void wxLog::DoLogTextAtLevel | ( | wxLogLevel | level,
|  | const wxString & | msg |
| ) |  |  | `[protected, virtual]`

Called to log the specified string at given level.

The base class versions logs debug and trace messages on the system default debug output channel and passes all the other messages to DoLogText().

static void wxLog::DontCreateOnDemand | ( |  | ) | `[static]`

Instructs wxLog to not create new log targets on the fly if there is none currently (see GetActiveTarget()).

(Almost) for internal use only: it is supposed to be called by the application shutdown code (where you don't want the log target to be automatically created anymore).

Note that this function also calls ClearTraceMasks().

static bool wxLog::EnableLogging | ( | bool | enable = `true` | ) | `[static]`

Globally enable or disable logging.

Calling this function with false argument disables all log messages for the current thread.

See also:
  wxLogNull, IsEnabled()

Returns:
  The old state, i.e. true if logging was previously enabled and false if it was disabled.

virtual void wxLog::Flush | ( |  | ) | `[virtual]`

Some of wxLog implementations, most notably the standard wxLogGui class, buffer the messages (for example, to avoid showing the user a zillion of modal message boxes one after another -- which would be really annoying).

This function shows them all and clears the buffer contents. If the buffer is already empty, nothing happens.

If you override this method in a derived class, call the base class version first, before doing anything else.

Reimplemented in wxLogGui, and wxLogBuffer.

static void wxLog::FlushActive | ( |  | ) | `[static]`

Flushes the current log target if any, does nothing if there is none.

When this method is called from the main thread context, it also flushes any previously buffered messages logged by the other threads. When it is called from the other threads it simply calls Flush() on the currently active log target, so it mostly makes sense to do this if a thread has its own logger set with SetThreadActiveTarget().

static wxLog* wxLog::GetActiveTarget | ( |  | ) | `[static]`

Returns the pointer to the active log target (may be NULL).

Notice that if SetActiveTarget() hadn't been previously explicitly called, this function will by default try to create a log target by calling wxAppTraits::CreateLogTarget() which may be overridden in a user-defined traits class to change the default behaviour. You may also call DontCreateOnDemand() to disable this behaviour.

When this function is called from threads other than main one, auto-creation doesn't happen. But if the thread has a thread-specific log target previously set by SetThreadActiveTarget(), it is returned instead of the global one. Otherwise, the global log target is returned.

static wxLogLevel wxLog::GetLogLevel | ( |  | ) | `[static]`

Returns the current log level limit.

All messages at levels strictly greater than the value returned by this function are not logged at all.

See also:
  SetLogLevel(), IsLevelEnabled()

static bool wxLog::GetRepetitionCounting | ( |  | ) | `[static]`

Returns whether the repetition counting mode is enabled.

static const wxString& wxLog::GetTimestamp | ( |  | ) | `[static]`

Returns the current timestamp format string.

static const wxArrayString& wxLog::GetTraceMasks | ( |  | ) | `[static]`

Returns the currently allowed list of string trace masks.

See also:
  AddTraceMask().

static bool wxLog::GetVerbose | ( |  | ) | `[static]`

Returns whether the verbose mode is currently active.

static bool wxLog::IsAllowedTraceMask | ( | const wxString & | mask | ) | `[static]`

Returns true if the mask is one of allowed masks for wxLogTrace().

See also: AddTraceMask(), RemoveTraceMask()

static bool wxLog::IsEnabled | ( |  | ) | `[static]`

Returns true if logging is enabled at all now.

See also:
  IsLevelEnabled(), EnableLogging()

static bool wxLog::IsLevelEnabled | ( | wxLogLevel | level,
|  | wxString | component |
| ) |  |  | `[static]`

Returns true if logging at this level is enabled for the current thread.

This function only returns true if logging is globally enabled and if level is less than or equal to the maximal log level enabled for the given component.

See also:
  IsEnabled(), SetLogLevel(), GetLogLevel(), SetComponentLevel()

Since:
  2.9.1

void wxLog::LogRecord | ( | wxLogLevel | level,
|  | const wxString & | msg,
|  | time_t | timestamp |
| ) |  |  |

Log the given record.

This function should only be called from the DoLog() implementations in the derived classes if they need to call DoLogRecord() on another log object (they can, of course, just use wxLog::DoLogRecord() call syntax to call it on the object itself). It should not be used for logging new messages which can be only sent to the currently active logger using OnLog() which also checks if the logging (for this level) is enabled while this method just directly calls DoLog().

Example of use of this class from wxLogChain:

            void wxLogChain::DoLogRecord(wxLogLevel level,
                                         const wxString& msg,
                                         const wxLogRecordInfo& info)
            {
                // let the previous logger show it
                if ( m_logOld && IsPassingMessages() )
                    m_logOld->LogRecord(level, msg, info);

                // and also send it to the new one
                if ( m_logNew && m_logNew != this )
                    m_logNew->LogRecord(level, msg, info);
            }

Since:
  2.9.1

static void wxLog::RemoveTraceMask | ( | const wxString & | mask | ) | `[static]`

Remove the mask from the list of allowed masks for wxLogTrace().

See also:
  AddTraceMask()

static void wxLog::Resume | ( |  | ) | `[static]`

Resumes logging previously suspended by a call to Suspend().

All messages logged in the meanwhile will be flushed soon.

static wxLog* wxLog::SetActiveTarget | ( | wxLog * | logtarget | ) | `[static]`

Sets the specified log target as the active one.

Returns the pointer to the previous active log target (may be NULL). To suppress logging use a new instance of wxLogNull not NULL. If the active log target is set to NULL a new default log target will be created when logging occurs.

See also:
  SetThreadActiveTarget()

static void wxLog::SetComponentLevel | ( | const wxString & | component,
|  | wxLogLevel | level |
| ) |  |  | `[static]`

Sets the log level for the given component.

For example, to disable all but error messages from wxWidgets network classes you may use

                wxLog::SetComponentLevel("wx/net", wxLOG_Error);

SetLogLevel() may be used to set the global log level.

Parameters:

  | component | Non-empty component name, possibly using slashes (`/`) to separate it into several parts.
  | level | Maximal level of log messages from this component which will be handled instead of being simply discarded.

Since:
  2.9.1

static void wxLog::SetLogLevel | ( | wxLogLevel | logLevel | ) | `[static]`

Specifies that log messages with level greater (numerically) than logLevel should be ignored and not sent to the active log target.

See also:
  SetComponentLevel()

static void wxLog::SetRepetitionCounting | ( | bool | repetCounting = `true` | ) | `[static]`

Enables logging mode in which a log message is logged once, and in case exactly the same message successively repeats one or more times, only the number of repetitions is logged.

static wxLog* wxLog::SetThreadActiveTarget | ( | wxLog * | logger | ) | `[static]`

Sets a thread-specific log target.

The log target passed to this function will be used for all messages logged by the current thread using the usual wxLog functions. This shouldn't be called from the main thread which never uses a thread- specific log target but can be used for the other threads to handle thread logging completely separately; instead of buffering thread log messages in the main thread logger.

Notice that unlike for SetActiveTarget(), wxWidgets does not destroy the thread-specific log targets when the thread terminates so doing this is your responsibility.

This method is only available if `wxUSE_THREADS` is 1, i.e. wxWidgets was compiled with threads support.

Parameters:

  | logger | The new thread-specific log target, possibly NULL.

Returns:
  The previous thread-specific log target, initially NULL.

Since:
  2.9.1

static void wxLog::SetTimestamp | ( | const wxString & | format | ) | `[static]`

Sets the timestamp format prepended by the default log targets to all messages.

The string may contain any normal characters as well as % prefixed format specifiers, see strftime() manual for details. Passing an empty string to this function disables message time stamping.

static void wxLog::SetVerbose | ( | bool | verbose = `true` | ) | `[static]`

Activates or deactivates verbose mode in which the verbose messages are logged as the normal ones instead of being silently dropped.

The verbose messages are the trace messages which are not disabled in the release mode and are generated by wxLogVerbose().

See also:
  wxLog Classes Overview

static void wxLog::Suspend | ( |  | ) | `[static]`

Suspends the logging until Resume() is called.

Note that the latter must be called the same number of times as the former to undo it, i.e. if you call Suspend() twice you must call Resume() twice as well.

Note that suspending the logging means that the log sink won't be flushed periodically, it doesn't have any effect if the current log target does the logging immediately without waiting for Flush() to be called (the standard GUI log target only shows the log dialog when it is flushed, so Suspend() works as expected with it).

See also:
  Resume(), wxLogNull

|  | [ top ]